"""
# self.sigma: dict[str, dict[NodePtr, np.ndarray]] = {}  # sigma[player][info_set][act]
# self.R: dict[str, dict[NodePtr, np.ndarray]] = {}  # R[player][info_set][act]

def bfs_stat(self):
    bfs_layers = []
    parent_layer = [self.root]
    child_layer = []
    while True:
        bfs_layers.append(parent_layer)
        for n in parent_layer:
            for i in range(len(n.o.actA)):
                for j in range(len(n.o.actB)):
                    child_layer.append(n.o.get_child(i, j))
        if len(child_layer) == 0:
            break
        else:
            parent_layer = child_layer
            child_layer = []
    return bfs_layers
"""

"""
def sigma_update(self, t: int):
    for l in self.bfs[0:-2]:
        for n in l:
            A = np.zeros([len(n.o.actA), len(n.o.actB)], dtype=float)
            B = np.zeros([len(n.o.actA), len(n.o.actB)], dtype=float)
            for i in range(len(n.o.actA)):
                for j in range(len(n.o.actB)):
                    A[i, j], B[i, j] = self.cfv_all[n.o.get_child(i, j)]
            # ACT: this is where loop STARTS!
            u = A @ self.sigma["A"][n]
            v = B.T @ self.sigma["B"][n]
            ra = u - self.sigma["A"][n].T @ u
            rb = v - self.sigma["B"][n].T @ v
            ra[ra < 0] *= 0.1
            rb[rb < 0] *= 0.1

            self.R["A"][n] += ra
            self.R["B"][n] += rb
            self.R["A"][n][self.R["A"][n] < 0] = 0
            self.R["B"][n][self.R["B"][n] < 0] = 0
            self.sigma["A"][n] = self.R["A"][n] / self.R["A"][n].sum()
            self.sigma["B"][n] = self.R["B"][n] / self.R["B"][n].sum()


def cfv_update(self):
    for l in self.bfs[-3::-1]:
        for n in l:
            A = np.zeros([len(n.o.actA), len(n.o.actB)], dtype=float)
            B = np.zeros([len(n.o.actA), len(n.o.actB)], dtype=float)
            for i in range(len(n.o.actA)):
                for j in range(len(n.o.actB)):
                    A[i, j], B[i, j] = self.cfv_all[n.o.get_child(i, j)]
            self.cfv_all[n][0] = (A @ self.sigma["A"][n]) @ self.sigma["B"][n]
            self.cfv_all[n][1] = (B @ self.sigma["A"][n]) @ self.sigma["B"][n]
"""


